#!/usr/bin/perl
#
# dcnote-smil : 
#   ޥե
# Copyright (C) GFD_Dennou_Club, 2001.  All rights reserved.
#
#  Usage : dcreal-smil.pl 
#
#   2001/04/10 ̰ϯ;
#       2002/11/27 
#
######################################################################
# եɤ߹
require "./Mkinclude.pl";

# ץ
while (@ARGV) {
    last unless ($ARGV[0] =~ /^-/);
    $_ = shift;                           
    if (/^-f/) { $TRTFILE = shift; next; };   # ߥ󥰥ե̾
    if (/^-e/) { $EXT = shift; next; };       # ϥե
    if (/^-w/) { $WIDTH = shift; next; };     # RealPlayer β̤
    if (/^-h/) { $HEIGHT = shift; next; };    # RealPlayer β̤ι⤵
    if (/^-v/) { $VIDEO_WIDTH = shift; next; }; # ӥǥ 
    if (/^-t/) { $TITLE = shift; next; };     # ֱ饿ȥ
    if (/^-n/) { $NAME = shift; next; };      # ֱ̾
    if (/^-c/) { $COPYRIGHT = shift; next; }; # ԡ饤
    if (/^-r/) { $VIDEO = shift; next; };     # rm ե̾
    if (/^-d/) { $DURATION = shift; next; };  # rm եη³
    if (/^--with-no-video/) { $SHOW = "off"; next; }; # ӥǥܥդʤ
    die "unknown option $_";
}

# ѤȤƻȤ빭׻
$IMG_WIDTH = $WIDTH - $VIDEO_WIDTH; 

# RealPix ե̾
$PIX = $VIDEO;
$PIX =~ s/rm$/rp/;

# Ǽǥ쥯ȥ
$VIDEODIR = "../$PUBDIR_real";
$SMILDIR = "$VIDEODIR/smi";
$IMGDIR = "$VIDEODIR/img-real";

mkdir $VIDEODIR, 0777  unless -d $VIDEODIR ;
mkdir $SMILDIR, 0777  unless -d $SMILDIR ;

#եΥ
unless (-d $IMGDIR) {
    mkdir $IMGDIR, 0777  unless -d $IMGDIR ;
    system("cd $IMGDIR; ln -s ../../src/img-real/* ./");
}

#RealMedia Υ
system("cd $VIDEODIR; ln -s ../src/$VIDEO ./");

print "$VIDEO \n"; 

## ӥǥѤΥ󥯤
#unless ($SHOW =~/off/){
#    system("ln -s ./$VIDEO $VIDEODIR/");
#}

#ߥ󥰥ե뤬¸ߤ뤫ǧ
unless (-f $TRTFILE) {
    print "Not $TRTFILE \n"; 
    exit 1;
}

#ߥ󥰥եΥץ, ɬפʾ. 
open (TIMING, "$TRTFILE");
$i = 0;
while (<TIMING>) {
    chomp(@_);
    #ϻ, OHP ֹ, OHP ȥ̡¸
    $_ =~ /([0-9]+:[0-9]+:[0-9]+),(\d+):(.*)/;
    $time[$i] = $1;
    $ohp_num[$i] = $2;
    $ohp_title[$i] = $3;
    $i++;
    $ohpfile .= "$2;"; 
    print "$1, $2, $3 \n"; 
}
close (TIMING);


#ɬפʥեȽ
@ohps = split(/;/, $ohpfile);
@ohps = sort(@ohps);     

$ohp_pre = @ohps[0];
$ohp_nxt = "@ohps[0];"; 

foreach $ohp (@ohps) {
    print "$ohp_pre $ohp\n"; 

    if ($ohp_pre ne $ohp) {
	print "check $ohp \n"; 
	$ohp_nxt .= "$ohp;"; 
    }
    $ohp_pre = $ohp
}
@ohps = split(/;/, $ohp_nxt);


# SMIL եκ
$i = 0;
while ($ohp_num[$i]) {
    #ե̾ν
    $num = sprintf("%03d", $ohp_num[$i]);

    #˥ե뤬¸ߤʤΤ SMIL ե
    $smifile = "$SMILDIR/$num.smi";
    unless (-f $smifile) {
	&print_smi($smifile, $time[$i]);
    }  
    $i++;
}

# RealPix եκ
&print_rp();

exit 0;

#=======================================================================


# SMIL եѥ֥롼
sub print_smi{
    my($smifile, $time) = @_;
    open (SMIL, ">$smifile");
	
    #եؤν񤭽Ф. ꡹ѿ. 
    print SMIL <<EOT
<smil>
  <head>
    <meta name="title" content="$TITLE"/>
    <meta name="author" content="$NAME"/>
    <meta name="copyright" content="$COPYRIGHT"/>
  <layout>
    <root-layout width="$WIDTH" height="$HEIGHT"/>
    <region id="pix" top="0" left="0" width="$IMG_WIDTH" height="$HEIGHT"/>
    <region id="main" top="0" left="$IMG_WIDTH" width="$VIDEO_WIDTH" height="$HEIGHT"/>
  </layout>
</head>
<body>
  <par>
     <seq>
      <video src="../$VIDEO" region="main" clip-begin="$time"/>
     </seq>
     <img src="../$PIX" region="pix" clip-begin="$time"/>
  </par>
</body>
</smil>
EOT
;
    close (SMIL);
}


# RealPix ѥ֥롼
sub print_rp{
    open (RP, ">$VIDEODIR/$PIX");
    #إåκ
    print RP <<EOT1
   <imfl>
    <head width="$IMG_WIDTH" height="$HEIGHT" start="0" duration="$DURATION" title="$TITLE" bitrate="3000" timeformat="dd:hh:mm:ss.xyz"/>
EOT1
    ;
    
    #ϥɥκ
    foreach $ohp (@ohps) { 
	$num = sprintf("%03d", $ohp);
	print RP "<image handle=\"$ohp\" name=\"img-real/$num.$EXT\"/> \n";
    }

#ǡν񤭽Ф
    print RP <<EOT2
<fill start="0" color="black"/>
<fadein start="00:00:00" duration="3" target="$ohp_num[0]"/>
EOT2
    ;

    $i = 1;
    while ($ohp_num[$i]) { 
	print "$ohp_num[$i] \n"; 
	$num = sprintf("%03d", $ohp_num[$i]);
	print RP "<wipe type=\"push\" direction=\"left\" start=\"$time[$i]\" duration=\"3\" target=\"$ohp_num[$i]\"/> \n";
	$i++
    }
    print RP "</imfl> \n";
    close(RP);
}




